#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int arr[26];

int main()
{
	int n, m, t;
	cin >> n >> m >> t;

	vector<pair<int, char> > tubes(n);
	for (int i = 0; i < n - 1; i++)
	{
		cin >> tubes[i].first >> tubes[i].second;
		arr[tubes[i].second - 'a']++;
	}

	vector<int> min_cost(26, 1e8);
	for (int i = 0; i < m; i++)
	{
		int cost;
		char c;
		cin >> cost >> c;
		min_cost[c - 'a'] = min(min_cost[c - 'a'], cost);
	}

	long long ans = 0;
	for (int i = 0; i < 26; i++)
	{
		ans += min_cost[i] * arr[i];
	}

	cout << ans << endl;

	return 0;
}