#include <iostream>
#include <cstdio>
#include <istream>
#include <vector>
#include <algorithm>
#include <map>
#include "Source.h"

using namespace std;

long long arr[26];
map<string, long long> min_cost;
map<int, int> graph;
bool flag = true;
string word = "";
vector<pair<long long, char> > tubes;

int main()
{
	long long n, m, t;
	cin >> n >> m >> t;

	tubes.resize(n);
	tubes[0].second = ' ';
	for (int i = 1; i < (long long)(n); i++)
	{
		cin >> tubes[i].first >> tubes[i].second;
		tubes[i].first--;
		graph[i] = tubes[i].first;
		graph[tubes[i].first] = i;
		arr[tubes[i].second - 'a']++;
	}

	for (int i = 0; i < m; i++)
	{
		long long cost;
		string str;
		cin >> cost;
		cin >> str;
		if (str.size() > 1)
			flag = false;
		if (min_cost[str] == 0)
			min_cost[str] = cost;
		min_cost[str] = min(min_cost[str], cost);
	}

	long long ans = 0;
	if (flag)
	{
		for (int i = 0; i < 26; i++)
		{
			char ch = i + 'a';
			string str = "" + ch;
			ans += min_cost[str] * arr[i];
		}
	if (ans >= 10000000000000000)
		cout << -1 << endl;
	else
		cout << ans << endl;	
	}
	else
	{
		int v = 0;
		vector<bool> used(n, false);
		while (true)
		{
			used[v] = true;
			word = word + tubes[v].second;
			v = graph[v];
			if (used[v])
				break;
		}
		vector<long long> dp(n, 10000000000000000);
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < i; j++)
			{
				if (min_cost[word.substr(j, i)] != 0)
					dp[i] = min(dp[i], dp[j] + min_cost[word.substr(j, i)]);
			}
		}

		cout << dp[n - 1];
	}

	return 0;
}