#include <iostream>
#include <algorithm>

using namespace std;

long long INF = 1000000000000000;

long long f(long long m, long long s)
{
	if (s == 0)
		return 0;
	if (s < 0)
		return INF;
	long long ans = INF;
	for (int i = m + 1; i <= s; i++)
		ans = min(ans, i - m - 1 + f(i, s - i));
	return ans;
}

int main()
{
	long long k, s;

	cin >> k >> s;

	long long res = f(k, s) + k;

	cout << res << endl;

	return 0;
}