#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

struct query
{
	long long time, floor, ind;

	query(long long _time = 0, long long _floor = 0, long long _ind = 0)
	{
		time = _time;
		floor = _floor;
		ind = _ind;
	}
};

bool comp(query q1, query q2)
{
	if ((q1.time < q2.time) || ((q1.time == q2.time) && (q1.floor < q2.floor)))
		return true;
	return false;
}

int main()
{
	long long n, m;
	cin >> n >> m;

	vector<long long> anses(n, 0);

	vector<query> Q(n);
	vector<query> Qtmp;
	for (long long i = 0; i < n; i++)
	{
		long long time, floor;
		cin >> time >> floor;
		Q[i] = query(time, floor, i);
	}

	long long Lt = 0;
	while (!Q.empty())
	{
		Qtmp.clear();

		long long T = max(Q[0].time, Lt), F = Q[0].floor;
		for (long long i = 0; i < (long long)(Q.size()); i++)
		{
			if (((T + F - 1 + F - Q[i].floor) >= Q[i].time) && (Q[i].floor <= F))
			{
				anses[Q[i].ind] = T + 2 * F - 2;
			}
			else
				Qtmp.push_back(Q[i]);
		}

		Lt = T + 2 * F - 2;
		Q = Qtmp;
	}

	for (long long i = 0; i < n; i++)
		cout << anses[i] << ' ';

	return 0;
}