#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long arr[26];

int main()
{
	long long n, m, t;
	cin >> n >> m >> t;

	vector<pair<long long, char> > tubes(n);
	for (int i = 0; i < n - 1; i++)
	{
		cin >> tubes[i].first >> tubes[i].second;
		arr[tubes[i].second - 'a']++;
	}

	vector<long long> min_cost(26, 10000000000000000);
	for (int i = 0; i < m; i++)
	{
		long long cost;
		char c;
		cin >> cost >> c;
		min_cost[c - 'a'] = min(min_cost[c - 'a'], cost);
	}

	long long ans = 0;
	for (int i = 0; i < 26; i++)
	{
		ans += min_cost[i] * arr[i];
	}

	if (ans >= 10000000000000000)
		cout << -1 << endl;
	else
		cout << ans << endl;

	return 0;
}