#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

long long INF = 1000000000000000;

long long f(long long m, long long s)
{
	if (s == 0)
		return 0;
	if (s < 0)
		return INF;
	long long ans = INF;
	for (int i = m + 1; i <= s; i++)
		ans = min(ans, i - m - 1 + f(i, s - i));
	return ans;
}

long long g(long long x)
{
	long long r = 2;
	while (true)
	{
		if (x <= r)
			return (x != 1);
		x -= r;
		r++;
	}
}

long long h(long long m, long long x)
{
	long long r = m;
	x -= r;
	r += 2;
	long long c = 1;
	while (true)
	{
		if (x <= r)
		{
			if (x == 1)
				return 0;
			return ceil((x - 1.0) / c);
		}

		x -= r;
		r++;
		c++;
	}
}

int main()
{
	/*for (int i = 1; i <= 100; i++)
		cout << f(10, i) + 10 <<' ' << h(10, i) + 10 << endl;
*/
	long long k, s;

	cin >> k >> s;

	long long res = h(k, s) + k;

	cout << res << endl;

	return 0;
}